﻿using System;
using System.ComponentModel;
using System.Windows.Forms;
using H1xSDK;

namespace BarcodeDeviceProperties
{
    public partial class Form1 : Form
    {
        BarcodeDevice barcodeDevice = new BarcodeDevice();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            checkBoxBarcodeReader.Checked = barcodeDevice.BarcodeReaderEnabled;
            checkBoxKeyboardHook.Checked = barcodeDevice.KeyboardHook;
 
            // Set the additional trigger key.
            switch( barcodeDevice.TriggerKey )
            {
                case BarcodeDevice.TriggerKeys.KEY_NONE:
                    cmboTriggerKey.SelectedIndex = 0;
                    break;
                case BarcodeDevice.TriggerKeys.KEY_START:
                    cmboTriggerKey.SelectedIndex = 1;
                    break;
                case BarcodeDevice.TriggerKeys.KEY_OK:
                    cmboTriggerKey.SelectedIndex = 2;
                    break;
            }
        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            // Cleanup the BarcodeDevice by disposing barcodeDevice
            barcodeDevice.Dispose();
        }

        private void checkBoxBarcodeReader_CheckStateChanged(object sender, EventArgs e)
        {
            barcodeDevice.BarcodeReaderEnabled = checkBoxBarcodeReader.Checked;
        }

        private void checkBoxKeyboardHook_CheckStateChanged(object sender, EventArgs e)
        {
            barcodeDevice.KeyboardHook = checkBoxKeyboardHook.Checked;
        }

        private void btnModuleType_Click(object sender, EventArgs e)
        {
            MessageBox.Show(barcodeDevice.ModuleType.ToString());
        }

        private void btnModuleVersion_Click(object sender, EventArgs e)
        {
            MessageBox.Show(barcodeDevice.ModuleVersion);
        }

        private void cmboTriggerKey_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (cmboTriggerKey.SelectedIndex)
            { 
                case 0:
                    barcodeDevice.TriggerKey = BarcodeDevice.TriggerKeys.KEY_NONE;
                    break;
                case 1:
                    barcodeDevice.TriggerKey = BarcodeDevice.TriggerKeys.KEY_START; 
                    break;
                case 2:
                    barcodeDevice.TriggerKey = BarcodeDevice.TriggerKeys.KEY_OK;
                    break;
            }
        }
    }
}