﻿using System;
using System.ComponentModel;
using System.Windows.Forms;
using H1xSDK;

namespace EnableBarcodeTypes
{
    public partial class Form1 : Form
    {
        ScanBarcode scanBarcode = new ScanBarcode();
      
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            listVWBarcodeTypes.Items[0].Tag = ScanBarcode.BarcodeTypes.ID_UPC;
            listVWBarcodeTypes.Items[1].Tag = ScanBarcode.BarcodeTypes.ID_EAN;
            listVWBarcodeTypes.Items[2].Tag = ScanBarcode.BarcodeTypes.ID_CODE_39;
            listVWBarcodeTypes.Items[3].Tag = ScanBarcode.BarcodeTypes.ID_TRIOPTIC;
            listVWBarcodeTypes.Items[4].Tag = ScanBarcode.BarcodeTypes.ID_CODABAR;
            listVWBarcodeTypes.Items[5].Tag = ScanBarcode.BarcodeTypes.ID_INDUSTRIAL;
            listVWBarcodeTypes.Items[6].Tag = ScanBarcode.BarcodeTypes.ID_INTERLEAVED;
            listVWBarcodeTypes.Items[7].Tag = ScanBarcode.BarcodeTypes.ID_SCODE;
            listVWBarcodeTypes.Items[8].Tag = ScanBarcode.BarcodeTypes.ID_MATRIX;
            listVWBarcodeTypes.Items[9].Tag = ScanBarcode.BarcodeTypes.ID_CHINESE;
            listVWBarcodeTypes.Items[10].Tag = ScanBarcode.BarcodeTypes.ID_KOREAN;
            listVWBarcodeTypes.Items[11].Tag = ScanBarcode.BarcodeTypes.ID_IATA;
            listVWBarcodeTypes.Items[12].Tag = ScanBarcode.BarcodeTypes.ID_MSI;
            listVWBarcodeTypes.Items[13].Tag = ScanBarcode.BarcodeTypes.ID_TELEPEN;
            listVWBarcodeTypes.Items[14].Tag = ScanBarcode.BarcodeTypes.ID_UK;
            listVWBarcodeTypes.Items[15].Tag = ScanBarcode.BarcodeTypes.ID_CODE_128;
            listVWBarcodeTypes.Items[16].Tag = ScanBarcode.BarcodeTypes.ID_CODE_93;
            listVWBarcodeTypes.Items[17].Tag = ScanBarcode.BarcodeTypes.ID_CODE_11;
            listVWBarcodeTypes.Items[18].Tag = ScanBarcode.BarcodeTypes.ID_RSS;
            listVWBarcodeTypes.Items[19].Tag = ScanBarcode.BarcodeTypes.ID_RSS_LMT;
            listVWBarcodeTypes.Items[20].Tag = ScanBarcode.BarcodeTypes.ID_RSS_EXP;
            listVWBarcodeTypes.Items[21].Tag = ScanBarcode.BarcodeTypes.ID_DMATRIX;
            listVWBarcodeTypes.Items[22].Tag = ScanBarcode.BarcodeTypes.ID_DMATRIX_200;
            listVWBarcodeTypes.Items[23].Tag = ScanBarcode.BarcodeTypes.ID_AZTEC;
            listVWBarcodeTypes.Items[24].Tag = ScanBarcode.BarcodeTypes.ID_AZTECRUN;
            listVWBarcodeTypes.Items[25].Tag = ScanBarcode.BarcodeTypes.ID_QR;
            listVWBarcodeTypes.Items[26].Tag = ScanBarcode.BarcodeTypes.ID_MAXI;
            listVWBarcodeTypes.Items[27].Tag = ScanBarcode.BarcodeTypes.ID_PDF417;
            listVWBarcodeTypes.Items[28].Tag = ScanBarcode.BarcodeTypes.ID_MICROPDF;
            listVWBarcodeTypes.Items[29].Tag = ScanBarcode.BarcodeTypes.ID_ALL_ADDONS;

            ScanBarcode.BarcodeTypes suppBarTypes = scanBarcode.SupportedBarcodeTypes;
            // Check what items are available according to the supported barcode types
            for (int x = 0; x < listVWBarcodeTypes.Items.Count; x++)
            {
                if( ((uint)suppBarTypes & (uint)listVWBarcodeTypes.Items[ x ].Tag) != (uint)listVWBarcodeTypes.Items[ x ].Tag )
                {
                    // barcode type is not supported so remove it from the list
                    listVWBarcodeTypes.Items.Remove(listVWBarcodeTypes.Items[x]);
                    x--;
                }
            }

            ScanBarcode.BarcodeTypes enabledBarTypes = scanBarcode.EnabledBarcodeTypes;
            for (int x = 0; x < listVWBarcodeTypes.Items.Count; x++)
            {
                if (((uint)enabledBarTypes & (uint)listVWBarcodeTypes.Items[ x ].Tag) == (uint)listVWBarcodeTypes.Items[ x ].Tag )
                    listVWBarcodeTypes.Items[x].Checked = true;
                else
                    listVWBarcodeTypes.Items[x].Checked = false;
            }
        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            scanBarcode.Dispose(); 
        }

        private void btnApply_Click(object sender, EventArgs e)
        {
            ScanBarcode.BarcodeTypes enabledBarTypes = 0;

            for (int x = 0; x < listVWBarcodeTypes.Items.Count; x++)
            {
                if (listVWBarcodeTypes.Items[x].Checked)
                    enabledBarTypes |= (ScanBarcode.BarcodeTypes)listVWBarcodeTypes.Items[x].Tag;
            }
            scanBarcode.EnabledBarcodeTypes = enabledBarTypes;
        }
    }
}