﻿using System;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using H1xSDK;

namespace GoodRead
{
    public partial class Form1 : Form
    {
        // Create a new instance of the ScanBarcode class
        ScanBarcode scanBarcode = new ScanBarcode();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Set or clear the checkbox
            chkGRSound.Checked = scanBarcode.GoodReadSoundEnable; 

            // Set the goodread sound file in the label
            textBoxGRSound.Text = scanBarcode.GoodReadSoundFile; 
        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            scanBarcode.Dispose();
        }

        private void btnSetGoodReadSound_Click(object sender, EventArgs e)
        {
            FileInfo file = new FileInfo( textBoxGRSound.Text );
            if (file.Exists)
            {
                if (file.Extension.ToLower() == ".wav")
                {
                    scanBarcode.GoodReadSoundFile = textBoxGRSound.Text;
                    MessageBox.Show("File: " + textBoxGRSound.Text + " set.");
                }
                else
                    MessageBox.Show("File has not the WAV extension");
            }
            else
                MessageBox.Show("File does not exist");
        }

        private void chkGRSound_CheckStateChanged(object sender, EventArgs e)
        {
            scanBarcode.GoodReadSoundEnable = chkGRSound.Checked; 
        }

    }
}