﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using H1xSDK;

namespace UpdateFirmware
{
    public partial class Form1 : Form
    {
        BarcodeDevice barcodeDevice = new BarcodeDevice();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Add the event handlers
            barcodeDevice.UpdateFwProgress += new BarcodeDevice.UpdateFwProgressEventHandler(UpdateProgressEvent);
            barcodeDevice.UpdateFwProgressStatus += new BarcodeDevice.UpdateFwProgressStatusEventHandler(UpdateProgressStatus);
            barcodeDevice.UpdateFwFinalResult += new BarcodeDevice.UpdateFwFinalResultEventHandler(UpdateFinalResult);

        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            barcodeDevice.Dispose();
        }

        private void btnUpdateFW_Click(object sender, EventArgs e)
        {
            OpenFileDialog fileDlg = new OpenFileDialog();
            fileDlg.Filter = "Firmware Files(*.BIN;*.HEX)|*.BIN;*.HEX|All files (*.*)|*.*";
            fileDlg.FilterIndex = 0;
            
            if( fileDlg.ShowDialog() == DialogResult.OK )
            {
                ReturnValues retVal = barcodeDevice.UpdateFirmware(textBoxPassword.Text, fileDlg.FileName);
                if (retVal != ReturnValues.SUCCESS)
                    MessageBox.Show(retVal.ToString());
            }
            fileDlg.Dispose();
        }

        private void btnCancelUpdate_Click(object sender, EventArgs e)
        {
            barcodeDevice.CancelUpdateFirmware();
        }

        private void UpdateProgressEvent(int percentage)
        {
            progressBar1.Value = percentage;
        }

        private void UpdateProgressStatus(BarcodeDevice.FwProgressStatus progressStatus)
        {
            lblUpdateStatus.Text = progressStatus.ToString();
        }

        private void UpdateFinalResult(BarcodeDevice.FwFinalResult finalResult)
        {
            MessageBox.Show(finalResult.ToString());
            progressBar1.Value = 0;
            lblUpdateStatus.Text = "";
        }
    }
}