﻿Public Class Form1
    Dim WithEvents scanBarcode As New ScanBarcode()
    Dim barcodeDevice As New BarcodeDevice()
    Dim barcodeBuffer(4096) As Byte

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Enable the barcode device if needed
        If barcodeDevice.BarcodeReaderEnabled = False Then
            barcodeDevice.BarcodeReaderEnabled = True
        End If

        ' Set to no suffix
        BarcodeDevice.SetOptions("RZ", BarcodeDevice.MaskOptions.STRING)

        ' Handle the trigger and barcode data by the application
        barcodeDevice.KeyboardHook = False
    End Sub

    Private Sub Form1_Closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        barcodeDevice.Dispose()
        scanBarcode.Dispose()
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyCode
            Case Keys.Return, &HF4&
                barcodeDevice.TriggerPress()
                ' Set that the pressed key is already handled
                ' the framework does not need to handle it anymore
                e.Handled = True
        End Select
    End Sub

    Private Sub Form1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp
        Select Case e.KeyCode
            Case Keys.Return, &HF4&
                barcodeDevice.TriggerRelease()
                ' Set that the pressed key is already handled
                ' the framework does not need to handle it anymore
                e.Handled = True
        End Select

    End Sub

    Private Sub scanBarcode_BarcodeDataReceived() Handles scanBarcode.BarcodeDataReceived
        Dim rcvLength As Integer = scanBarcode.ReadBarcodeData(barcodeBuffer)

        Dim enc As New System.Text.ASCIIEncoding()

        textBoxBarcode.Text = enc.GetString(barcodeBuffer, 0, rcvLength)
    End Sub
End Class
