﻿Public Class Form1
    Dim barcodeDevice As New BarcodeDevice()
    Dim WithEvents captureImage As New CaptureImage()

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Disable the Keyboardhook
        barcodeDevice.KeyboardHook = False

        ' Set some of the image properties
        MenuItemRotate.Checked = captureImage.Rotate
        MenuItemAiming.Checked = captureImage.UseAimLed

        cmboImageFormat.SelectedIndex = 0   ' JPG
        cmboJpgQuality.SelectedIndex = 8    ' JPG quality 60%
        cmboResolution.SelectedIndex = 0    ' Full resolution
        cmboBPP.SelectedIndex = 2           ' 8 bits per pixel

        Dim imgRect As New Rectangle(0, 0, 1279, 1023)
        captureImage.ImageWindow = imgRect

    End Sub

    Private Sub Form1_Closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        ' Cleanup the resources
        barcodeDevice.Dispose()
        captureImage.Dispose()
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyCode
            Case Keys.Return, &HF4&
                barcodeDevice.TriggerPress()
                ' Set that the pressed key is already handled
                ' the framework does not need to handle it anymore
                e.Handled = True
        End Select
    End Sub

    Private Sub Form1_KeyUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp
        Select Case e.KeyCode
            Case Keys.Return, &HF4&
                barcodeDevice.TriggerRelease()
                ' Set that the pressed key is already handled
                ' the framework does not need to handle it anymore
                e.Handled = True
        End Select
    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Dim retValue As ReturnValues

        ' Set the image file format
        Select Case cmboImageFormat.SelectedIndex
            Case 0
                captureImage.FileFormat = captureImage.ImageFormat.FM_JPG
            Case 1
                captureImage.FileFormat = captureImage.ImageFormat.FM_BMP
            Case 2
                captureImage.FileFormat = captureImage.ImageFormat.FM_TIFF
        End Select

        ' Set the JPG image quality
        captureImage.JPGQuality = Convert.ToUInt32(cmboJpgQuality.SelectedItem.ToString())

        ' Set the used bits per pixel for Tiff and BMP
        Select Case cmboBPP.SelectedIndex
            Case 0
                captureImage.BitsPerPixel = captureImage.BitsPerPix.BPP_1
            Case 1
                captureImage.BitsPerPixel = captureImage.BitsPerPix.BPP_4
            Case 2
                captureImage.BitsPerPixel = captureImage.BitsPerPix.BPP_8
        End Select

        ' Set the selected resolution
        Select Case cmboResolution.SelectedIndex
            Case 0
                captureImage.Resolution = captureImage.Resolutions.RES_FULL
            Case 1
                captureImage.Resolution = captureImage.Resolutions.RES_1_4
            Case 2
                captureImage.Resolution = captureImage.Resolutions.RES_1_9
            Case 3
                captureImage.Resolution = captureImage.Resolutions.RES_1_16
        End Select

        ' Take the picture 
        retValue = captureImage.TakeSnapShot("\My documents\My Pictures", "MyImage")
        If retValue <> ReturnValues.SUCCESS Then
            MessageBox.Show(retValue.ToString())
        End If
    End Sub

    Private Sub menuItemAiming_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemAiming.Click
        ' Toggle the check
        MenuItemAiming.Checked ^= True
        captureImage.UseAimLed = MenuItemAiming.Checked
    End Sub

    Private Sub menuItemRotate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemRotate.Click
        ' Toggle the check
        MenuItemRotate.Checked ^= True
        captureImage.Rotate = MenuItemRotate.Checked
    End Sub

    Private Sub captureImage_ImageDownloadStatus(ByVal downStatus As H1xSDK.CaptureImage.ImageDownStat) Handles captureImage.ImageDownloadStatus
        Me.Text = downStatus.ToString()
        If downStatus = captureImage.ImageDownStat.IMAGE_DWN_FILE_SAVED Then
            If captureImage.FileFormat = captureImage.ImageFormat.FM_JPG Then
                pictureBox1.Image = New System.Drawing.Bitmap("\My Documents\My pictures\MyImage.JPG")
            ElseIf captureImage.FileFormat = captureImage.ImageFormat.FM_BMP Then
                pictureBox1.Image = New System.Drawing.Bitmap("\My Documents\My pictures\MyImage.BMP")
            Else
                pictureBox1.Image = New System.Drawing.Bitmap("\My Documents\My pictures\MyImage.TIFF")
            End If
        End If
    End Sub

    Private Sub captureImage_ImageError(ByVal imageError As H1xSDK.ReturnValues) Handles captureImage.ImageError
        MessageBox.Show(imageError.ToString())
    End Sub

    Private Sub captureImage_ImageProgress(ByVal percentage As Integer) Handles captureImage.ImageProgress
        progressBar1.Value = percentage
    End Sub
End Class
